package nc.fp.ws.bill;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.impl.pubapp.pattern.data.bill.BillQuery;
import nc.itf.scmpub.reference.uap.pf.PfServiceScmUtil;
import nc.itf.so.m32.ISaleInvoiceMaintain;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.pf.IPFBusiAction;
import nc.jdbc.framework.SQLParameter;
import nc.jdbc.framework.processor.ArrayListProcessor;
import nc.vo.ic.m4c.entity.SaleOutBodyVO;
import nc.vo.ic.m4c.entity.SaleOutVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pub.workflownote.WorkflownoteVO;
import nc.vo.so.m30.entity.SaleOrderVO;
import nc.vo.so.m32.entity.SaleInvoiceBVO;
import nc.vo.so.m32.entity.SaleInvoiceVO;
import nc.vo.so.m32.util.SaleInvoiceVOCalculator;
import nccloud.openapi.scmpub.util.BillFieldsCodeToPkUtil;

/* loaded from: DealXSFP01bill.class */
public class DealXSFP01bill {
    public String getInfoToCreatBill(String jsonString) throws BusinessException {
        SaleInvoiceVO[] transOutVO;
        try {
            new JSONObject();
            JSONObject returnObj = new JSONObject();
            JSONObject receiveObj = JSON.parseObject(jsonString);
            String action = receiveObj.getString("action");
            if (action.toUpperCase().equals("APPROVE")) {
                IPFBusiAction service = (IPFBusiAction) NCLocator.getInstance().lookup(IPFBusiAction.class);
                String type = receiveObj.getString("type");
                String flag = receiveObj.getString("flag");
                if ("1".equals(type)) {
                    if ("Y".equals(flag)) {
                        transOutVO = dkcfaggvo(receiveObj);
                        if (transOutVO == null || transOutVO.length == 0) {
                            throw new BusinessException("转单失败，请检查");
                        }
                        if (transOutVO.length != 2) {
                            throw new BusinessException("拆分单据有误，请检查");
                        }
                    } else {
                        transOutVO = dkbcaggvo(receiveObj);
                        if (transOutVO == null || transOutVO.length == 0) {
                            throw new BusinessException("转单失败，请检查");
                        }
                        if (transOutVO.length != 1) {
                            throw new BusinessException("合并单据有误，所选出库不能合并开票，请检查业务单位等信息");
                        }
                    }
                } else {
                    transOutVO = dxbcaggvo(receiveObj);
                    if (transOutVO == null || transOutVO.length == 0) {
                        throw new BusinessException("转单失败，请检查");
                    }
                    if (transOutVO.length != 1) {
                        throw new BusinessException("合并单据有误，所选出库不能合并开票，请检查业务单位等信息");
                    }
                }
                InvocationInfoProxy.getInstance().setProperty("pushflag", "Y");
                for (int i = 0; i < transOutVO.length; i++) {
                    SaleInvoiceVOCalculator calculate = new SaleInvoiceVOCalculator(transOutVO[i]);
                    transOutVO[i].getParentVO().setStatus(2);
                    String matcalss = getStrFsql("select f.name from bd_marbasclass f where f.pk_marbasclass in (select w.pk_marbasclass from bd_material w where pk_material = '" + transOutVO[i].getChildrenVO()[0].getVbdef24() + "')");
                    transOutVO[i].getParentVO().setVnote("售" + matcalss);
                    for (int j = 0; j < transOutVO[i].getChildrenVO().length; j++) {
                        transOutVO[i].getChildrenVO()[j].setCrowno(String.valueOf((j + 1) * 10));
                        transOutVO[i].getChildrenVO()[j].setStatus(2);
                        transOutVO[i].getChildrenVO()[j].setVchangerate("1/1");
                        calculate.calculate(j, "nnum");
                    }
                }
                BillFieldsCodeToPkUtil.doTranslateVOFields(transOutVO);
                InvocationInfoProxy.getInstance().setGroupId(transOutVO[0].getParentVO().getPk_group());
                InvocationInfoProxy.getInstance().setUserId(transOutVO[0].getParentVO().getCreator());
                service.processBatch("WRITE", "32", transOutVO, (Object[]) null, (WorkflownoteVO) null, (HashMap) null);
                returnObj.put("returnFlag", "1");
                returnObj.put("message", "开票成功");
                returnObj.put("data", "[]");
            }
            if (action.toUpperCase().equals("UPDATE")) {
                ISaleInvoiceMaintain saleInvoiceMaintain = (ISaleInvoiceMaintain) NCLocator.getInstance().lookup(ISaleInvoiceMaintain.class);
                JSONObject billinfo = receiveObj.getJSONArray("billinfo").getJSONObject(0);
                String csaleinvoiceid = billinfo.getJSONObject("headvo").getString("csaleinvoiceid");
                String vnote = billinfo.getJSONObject("headvo").getString("vnote");
                String vdef4 = billinfo.getJSONObject("headvo").getString("vdef4");
                String vdef5 = billinfo.getJSONObject("headvo").getString("vdef5");
                String vbdef26 = billinfo.getJSONObject("headvo").getString("vbdef26");
                String vbdef5 = billinfo.getJSONObject("headvo").getString("vbdef5");
                SaleInvoiceVO[] invo = querydvo(new String[]{csaleinvoiceid});
                invo[0].getParentVO().setVdef4(vnote);
                invo[0].getParentVO().setVdef14(vdef4);
                invo[0].getParentVO().setVdef5(vdef5);
                invo[0].getParentVO().setStatus(1);
                String matcalss2 = getStrFsql("select f.name from bd_marbasclass f where f.pk_marbasclass in (select w.pk_marbasclass from bd_material w where pk_material = '" + invo[0].getChildrenVO()[0].getVbdef24() + "')");
                invo[0].getParentVO().setVnote("售" + matcalss2);
                for (int i2 = 0; i2 < invo[0].getChildrenVO().length; i2++) {
                    invo[0].getChildrenVO()[i2].setVbdef26(vbdef26);
                    invo[0].getChildrenVO()[i2].setVbdef5(vbdef5);
                    invo[0].getChildrenVO()[i2].setStatus(1);
                }
                InvocationInfoProxy.getInstance().setGroupId(invo[0].getParentVO().getPk_group());
                InvocationInfoProxy.getInstance().setUserId(invo[0].getParentVO().getCreator());
                saleInvoiceMaintain.updateSaleInvoice(invo);
                returnObj.put("returnFlag", "1");
                returnObj.put("message", "开票修改成功");
                returnObj.put("data", "[]");
            }
            if (action.toUpperCase().equals("DELETE")) {
                ISaleInvoiceMaintain saleInvoiceMaintain2 = (ISaleInvoiceMaintain) NCLocator.getInstance().lookup(ISaleInvoiceMaintain.class);
                String csaleinvoiceid2 = receiveObj.getJSONArray("billinfo").getJSONObject(0).getJSONObject("headvo").getString("csaleinvoiceid");
                SaleInvoiceVO[] invo2 = querydvo(new String[]{csaleinvoiceid2});
                InvocationInfoProxy.getInstance().setGroupId(invo2[0].getParentVO().getPk_group());
                InvocationInfoProxy.getInstance().setUserId(invo2[0].getParentVO().getCreator());
                saleInvoiceMaintain2.deleteSaleInvoice(invo2);
                returnObj.put("returnFlag", "1");
                returnObj.put("message", "撤回（删除）发票成功");
                returnObj.put("data", "[]");
            }
            return returnObj.toString();
        } catch (Exception e) {
            if (e.getMessage() == null) {
                throw new BusinessException("{\"returnFlag\":\"0\",\"message\":\"失败 :开票失败" + e.getMessage() + "\",\"data\":{ }}");
            }
            throw new BusinessException("{\"returnFlag\":\"0\",\"message\":\"失败 :开票失败" + e.getMessage().replace("\n", "").replace("\r", "") + "\",\"data\":{ }}");
        }
    }

    public SaleInvoiceVO[] dkcfaggvo(JSONObject billinfo) throws BusinessException {
        JSONObject receiveObj = billinfo.getJSONArray("billinfo").getJSONObject(0);
        JSONArray array = receiveObj.getJSONArray("childvo");
        JSONObject headvo = receiveObj.getJSONObject("headvo");
        SaleInvoiceVO[] transOutVO = new SaleInvoiceVO[array.size()];
        String csourcebill = billinfo.getString("csourcebill");
        if ("4C".equals(csourcebill)) {
            SaleOutVO[] purVO = queryovo(new String[]{headvo.getString("csrcid")});
            InvocationInfoProxy.getInstance().setGroupId(purVO[0].getParentVO().getPk_group());
            InvocationInfoProxy.getInstance().setUserId(purVO[0].getParentVO().getCreator());
            for (int i = 0; i < purVO[0].getBodys().length; i++) {
                UFDouble nsignnum = purVO[0].getBodys()[i].getNsignnum() == null ? new UFDouble(0) : purVO[0].getBodys()[i].getNsignnum();
                UFDouble naccumwastnum = purVO[0].getBodys()[i].getNaccumwastnum() == null ? new UFDouble(0) : purVO[0].getBodys()[i].getNaccumwastnum();
                purVO[0].getBodys()[i].setNinvoicenum(purVO[0].getBodys()[i].getNnum().sub(nsignnum).sub(naccumwastnum));
            }
            SaleInvoiceVO[] tempvo = PfServiceScmUtil.exeVOChangeByBizFlow("4C", "32", purVO);
            SaleInvoiceVO[] tempvo01 = (SaleInvoiceVO[]) PfServiceScmUtil.exeVOChangeByBizFlow("4C", "32", purVO);
            SaleInvoiceVO[] tempvo02 = (SaleInvoiceVO[]) PfServiceScmUtil.exeVOChangeByBizFlow("4C", "32", purVO);
            JSONObject childvo01 = JSONObject.parseObject(array.get(0).toString());
            JSONObject childvo02 = JSONObject.parseObject(array.get(1).toString());
            String nnum01 = childvo01.getString("nnum");
            if (tempvo[0].getChildrenVO().length == 1) {
                for (String itemkey : headvo.keySet()) {
                    tempvo01[0].getParentVO().setAttributeValue(itemkey, headvo.get(itemkey));
                    tempvo02[0].getParentVO().setAttributeValue(itemkey, headvo.get(itemkey));
                    if ("ctrantypeid".equals(itemkey)) {
                        String ctrantypeid = getStrFsql("select h.pk_billtypeid from bd_billtype h where h.pk_billtypecode = '" + headvo.get(itemkey) + "' and pk_group = (select pk_group from org_group)");
                        tempvo01[0].getParentVO().setCtrantypeid(ctrantypeid);
                        tempvo01[0].getParentVO().setVtrantypecode(headvo.get(itemkey).toString());
                        tempvo02[0].getParentVO().setCtrantypeid(ctrantypeid);
                        tempvo02[0].getParentVO().setVtrantypecode(headvo.get(itemkey).toString());
                    }
                }
                for (String itemkey2 : childvo01.keySet()) {
                    tempvo01[0].getChildrenVO()[0].setAttributeValue(itemkey2, childvo01.get(itemkey2));
                }
                for (String itemkey3 : childvo02.keySet()) {
                    tempvo02[0].getChildrenVO()[0].setAttributeValue(itemkey3, childvo02.get(itemkey3));
                }
            } else {
                UFDouble nnumtmp = new UFDouble(nnum01);
                UFDouble bnnumtmp = new UFDouble(0);
                UFDouble nnumtemp = new UFDouble(0);
                int in = 0;
                int i2 = 0;
                while (true) {
                    if (i2 >= tempvo[0].getChildrenVO().length) {
                        break;
                    }
                    UFDouble bnnum = tempvo01[0].getChildrenVO()[i2].getNnum();
                    bnnumtmp = bnnumtmp.add(bnnum);
                    if (nnumtmp.compareTo(bnnumtmp) >= 0) {
                        i2++;
                    } else {
                        SaleInvoiceBVO[] bvo01 = new SaleInvoiceBVO[i2 + 1];
                        for (int j = 0; j < i2 + 1; j++) {
                            for (String itemkey4 : childvo01.keySet()) {
                                if (!"nnum".equals(itemkey4) && !"norigtaxmny".equals(itemkey4)) {
                                    tempvo01[0].getChildrenVO()[j].setAttributeValue(itemkey4, childvo01.get(itemkey4));
                                }
                            }
                            if (j == i2) {
                                nnumtemp = tempvo01[0].getChildrenVO()[j].getNnum().sub(tempvo01[0].getChildrenVO()[j].getNnum().sub(bnnumtmp.sub(nnumtmp)));
                                tempvo01[0].getChildrenVO()[j].setNnum(tempvo01[0].getChildrenVO()[j].getNnum().sub(bnnumtmp.sub(nnumtmp)));
                            }
                            bvo01[j] = tempvo01[0].getChildrenVO()[j];
                            in++;
                        }
                        tempvo01[0].setChildrenVO(bvo01);
                    }
                }
                SaleInvoiceBVO[] bvo02 = new SaleInvoiceBVO[(tempvo[0].getChildrenVO().length - in) + 1];
                for (int i3 = in - 1; i3 < tempvo[0].getChildrenVO().length; i3++) {
                    if (i3 == in - 1) {
                        tempvo02[0].getChildrenVO()[i3].setNnum(nnumtemp);
                    }
                    bvo02[(i3 - in) + 1] = tempvo02[0].getChildrenVO()[i3];
                }
                tempvo02[0].setChildrenVO(bvo02);
            }
            transOutVO[0] = tempvo01[0];
            transOutVO[1] = tempvo02[0];
        }
        return transOutVO;
    }

    public SaleInvoiceVO[] dkbcaggvo(JSONObject billinfo) throws BusinessException {
        JSONObject receiveObj = billinfo.getJSONArray("billinfo").getJSONObject(0);
        JSONArray array = receiveObj.getJSONArray("childvo");
        JSONObject headvo = receiveObj.getJSONObject("headvo");
        SaleInvoiceVO[] tempvo = null;
        String csourcebill = billinfo.getString("csourcebill");
        if ("4C".equals(csourcebill)) {
            SaleOutVO[] purVO = queryovo(new String[]{headvo.getString("csrcid")});
            InvocationInfoProxy.getInstance().setGroupId(purVO[0].getParentVO().getPk_group());
            InvocationInfoProxy.getInstance().setUserId(purVO[0].getParentVO().getCreator());
            int n = 0;
            for (int i = 0; i < purVO[0].getBodys().length; i++) {
                if (purVO[0].getBodys()[i].getNnum().compareTo(new UFDouble(0)) > 0) {
                    n++;
                }
            }
            List<SaleOutBodyVO> svo = new ArrayList<>();
            int nn = 0;
            for (int i2 = 0; i2 < purVO[0].getBodys().length; i2++) {
                if (purVO[0].getBodys()[i2].getNnum().compareTo(new UFDouble(0)) > 0) {
                    UFDouble nsignnum = purVO[0].getBodys()[i2].getNsignnum() == null ? new UFDouble(0) : purVO[0].getBodys()[i2].getNsignnum();
                    UFDouble naccumwastnum = purVO[0].getBodys()[i2].getNaccumwastnum() == null ? new UFDouble(0) : purVO[0].getBodys()[i2].getNaccumwastnum();
                    purVO[0].getBodys()[i2].setNinvoicenum(purVO[0].getBodys()[i2].getNnum().sub(nsignnum).sub(naccumwastnum));
                    if (purVO[0].getBodys()[i2].getNinvoicenum().compareTo(UFDouble.ZERO_DBL) != 0) {
                        svo.add(purVO[0].getBodys()[i2]);
                    }
                    nn++;
                }
            }
            purVO[0].setChildrenVO((CircularlyAccessibleValueObject[]) svo.toArray(new SaleOutBodyVO[svo.size()]));
            tempvo = (SaleInvoiceVO[]) PfServiceScmUtil.exeVOChangeByBizFlow("4C", "32", purVO);
            for (String itemkey : headvo.keySet()) {
                tempvo[0].getParentVO().setAttributeValue(itemkey, headvo.get(itemkey));
                if ("ctrantypeid".equals(itemkey)) {
                    String ctrantypeid = getStrFsql("select h.pk_billtypeid from bd_billtype h where h.pk_billtypecode = '" + headvo.get(itemkey) + "' and pk_group = (select pk_group from org_group)");
                    tempvo[0].getParentVO().setCtrantypeid(ctrantypeid);
                    tempvo[0].getParentVO().setVtrantypecode(headvo.get(itemkey).toString());
                }
            }
            for (int i3 = 0; i3 < array.size(); i3++) {
                JSONObject childvo = array.getJSONObject(i3);
                for (String itemkey2 : childvo.keySet()) {
                    if (!"nnum".equals(itemkey2)) {
                        tempvo[0].getChildrenVO()[i3].setAttributeValue(itemkey2, childvo.get(itemkey2));
                    }
                }
            }
            UFDouble ntotalastnum = new UFDouble(headvo.getString("ntotalastnum"));
            UFDouble nnum = new UFDouble(0);
            int index = 1;
            for (int i4 = 0; i4 < tempvo[0].getChildrenVO().length; i4++) {
                nnum = nnum.add(tempvo[0].getChildrenVO()[i4].getNnum());
                if (nnum.compareTo(ntotalastnum) < 0) {
                    index++;
                }
            }
            if (ntotalastnum.compareTo(nnum) != 0) {
                SaleInvoiceBVO[] bvo = new SaleInvoiceBVO[index];
                UFDouble num = new UFDouble(0);
                for (int i5 = 0; i5 < tempvo[0].getChildrenVO().length; i5++) {
                    num = num.add(tempvo[0].getChildrenVO()[i5].getNnum());
                    if (num.compareTo(ntotalastnum) < 0) {
                        bvo[i5] = tempvo[0].getChildrenVO()[i5];
                    } else {
                        tempvo[0].getChildrenVO()[i5].setNnum(tempvo[0].getChildrenVO()[i5].getNnum().sub(num.sub(ntotalastnum)));
                        bvo[i5] = tempvo[0].getChildrenVO()[i5];
                    }
                }
                tempvo[0].setChildrenVO(bvo);
            }
        } else if ("30".equals(csourcebill)) {
            SaleOrderVO[] purVO2 = querypvo(new String[]{headvo.getString("csrcid")});
            InvocationInfoProxy.getInstance().setGroupId(purVO2[0].getParentVO().getPk_group());
            InvocationInfoProxy.getInstance().setUserId(purVO2[0].getParentVO().getCreator());
            tempvo = PfServiceScmUtil.exeVOChangeByBizFlow("30", "32", purVO2);
            for (String itemkey3 : headvo.keySet()) {
                tempvo[0].getParentVO().setAttributeValue(itemkey3, headvo.get(itemkey3));
                if ("ctrantypeid".equals(itemkey3)) {
                    String ctrantypeid2 = getStrFsql("select h.pk_billtypeid from bd_billtype h where h.pk_billtypecode = '" + headvo.get(itemkey3) + "' and pk_group = (select pk_group from org_group)");
                    tempvo[0].getParentVO().setCtrantypeid(ctrantypeid2);
                    tempvo[0].getParentVO().setVtrantypecode(headvo.get(itemkey3).toString());
                }
            }
            for (int i6 = 0; i6 < array.size(); i6++) {
                JSONObject childvo2 = array.getJSONObject(i6);
                for (String itemkey4 : childvo2.keySet()) {
                    tempvo[0].getChildrenVO()[i6].setAttributeValue(itemkey4, childvo2.get(itemkey4));
                }
            }
        }
        return tempvo;
    }

    public SaleInvoiceVO[] dxbcaggvo(JSONObject billinfo) throws BusinessException {
        SaleInvoiceVO[] transOutVO = null;
        JSONArray receiveObj = billinfo.getJSONArray("billinfo");
        List list = new ArrayList();
        for (int i = 0; i < receiveObj.size(); i++) {
            JSONObject billinfotmp = receiveObj.getJSONObject(i);
            JSONArray csrcid = billinfotmp.getJSONObject("headvo").getJSONArray("csrcid");
            for (int j = 0; j < csrcid.size(); j++) {
                list.add(csrcid.getString(j));
            }
        }
        String[] str = new String[list.size()];
        for (int i2 = 0; i2 < list.size(); i2++) {
            str[i2] = list.get(i2).toString();
        }
        String csourcebill = billinfo.getString("csourcebill");
        if ("4C".equals(csourcebill)) {
            SaleOutVO[] purVO = queryovo(removeDuplicates(str));
            InvocationInfoProxy.getInstance().setGroupId(purVO[0].getParentVO().getPk_group());
            InvocationInfoProxy.getInstance().setUserId(purVO[0].getParentVO().getCreator());
            for (int i3 = 0; i3 < purVO.length; i3++) {
                for (int j2 = 0; j2 < purVO[i3].getBodys().length; j2++) {
                    UFDouble nsignnum = purVO[i3].getBodys()[j2].getNsignnum() == null ? new UFDouble(0) : purVO[i3].getBodys()[j2].getNsignnum();
                    UFDouble naccumwastnum = purVO[i3].getBodys()[j2].getNaccumwastnum() == null ? new UFDouble(0) : purVO[i3].getBodys()[j2].getNaccumwastnum();
                    purVO[i3].getBodys()[j2].setNinvoicenum(purVO[i3].getBodys()[j2].getNnum().sub(nsignnum).sub(naccumwastnum));
                }
            }
            transOutVO = (SaleInvoiceVO[]) PfServiceScmUtil.exeVOChangeByBizFlow("4C", "32", purVO);
        }
        JSONObject billinfotmp2 = receiveObj.getJSONObject(0);
        JSONObject headvo = billinfotmp2.getJSONObject("headvo");
        for (int i4 = 0; i4 < transOutVO.length; i4++) {
            for (String itemkey : headvo.keySet()) {
                if ("ctrantypeid".equals(itemkey)) {
                    String ctrantypeid = getStrFsql("select h.pk_billtypeid from bd_billtype h where h.pk_billtypecode = '" + headvo.get(itemkey) + "' and pk_group = (select pk_group from org_group)");
                    transOutVO[i4].getParentVO().setCtrantypeid(ctrantypeid);
                    transOutVO[i4].getParentVO().setVtrantypecode(headvo.get(itemkey).toString());
                } else {
                    transOutVO[i4].getParentVO().setAttributeValue(itemkey, headvo.get(itemkey));
                }
            }
            for (int j3 = 0; j3 < transOutVO[i4].getChildrenVO().length; j3++) {
                String flag = "N";
                String matcode = getStrFsql("select code from bd_material where pk_material = '" + transOutVO[i4].getChildrenVO()[j3].getVbdef24() + "'");
                for (int m = 0; m < receiveObj.size() && !"Y".equals(flag); m++) {
                    JSONArray childvotmp = receiveObj.getJSONObject(m).getJSONArray("childvo");
                    int n = 0;
                    while (true) {
                        if (n >= childvotmp.size()) {
                            break;
                        }
                        JSONObject cldtmp = childvotmp.getJSONObject(n);
                        String vbdef24 = cldtmp.getString("vbdef24");
                        if (!matcode.equals(vbdef24)) {
                            n++;
                        } else {
                            transOutVO[i4].getChildrenVO()[j3].setVbdef26(cldtmp.getString("vbdef26"));
                            transOutVO[i4].getChildrenVO()[j3].setVbdef5(cldtmp.getString("vbdef5"));
                            flag = "Y";
                            break;
                        }
                    }
                }
            }
        }
        return transOutVO;
    }

    public static String[] removeDuplicates(String[] array) {
        Set<String> uniqueSet = new HashSet<>();
        for (String item : array) {
            uniqueSet.add(item);
        }
        return (String[]) uniqueSet.toArray(new String[0]);
    }

    public SaleOrderVO[] querypvo(String[] pk) {
        BillQuery<SaleOrderVO> billquery = new BillQuery<>(SaleOrderVO.class);
        SaleOrderVO[] aggvo = billquery.query(pk);
        return aggvo;
    }

    public SaleOutVO[] queryovo(String[] pk) {
        BillQuery<SaleOutVO> billquery = new BillQuery<>(SaleOutVO.class);
        SaleOutVO[] aggvo = billquery.query(pk);
        for (int i = 0; i < aggvo.length; i++) {
            List<SaleOutBodyVO> newSvo = new ArrayList<>();
            for (int j = 0; j < aggvo[i].getBodys().length; j++) {
                if (new UFDouble(0).compareTo(aggvo[i].getBodys()[j].getNnum()) != 0) {
                    newSvo.add(aggvo[i].getBodys()[j]);
                }
            }
            aggvo[i].setChildrenVO((CircularlyAccessibleValueObject[]) newSvo.toArray(new SaleOutBodyVO[newSvo.size()]));
        }
        return aggvo;
    }

    public SaleInvoiceVO[] querydvo(String[] pk) {
        BillQuery<SaleInvoiceVO> billquery = new BillQuery<>(SaleInvoiceVO.class);
        SaleInvoiceVO[] aggvo = billquery.query(pk);
        return aggvo;
    }

    public static String getStrFsql(String strsql) {
        IUAPQueryBS qryBS = (IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
        try {
            List list = (List) qryBS.executeQuery(strsql, (SQLParameter) null, new ArrayListProcessor());
            if (list != null && list.size() > 0) {
                String s = "";
                if (((Object[]) list.get(0))[0] != null) {
                    s = ((Object[]) list.get(0))[0].toString();
                }
                return s;
            }
            return null;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }
}
